<?php
define('FPDF_FONTPATH','font/');
require('fpdf.php');

function px2mm($px){
	return $px*25.4/72;
}
function hex2dec($color = "#000000"){
	$tbl_color = array();
	$tbl_color['R']=hexdec(substr($color, 1, 2));
	$tbl_color['G']=hexdec(substr($color, 3, 2));
	$tbl_color['B']=hexdec(substr($color, 5, 2));
	return $tbl_color;
}


function CleanFiles($dir)
{
    //Efface les fichiers temporaires

	$t=time();
    $h=opendir($dir);
    while($file=readdir($h))
    {
        if(substr($file,0,3)=='tem' and substr($file,-4)=='.pdf')
        {
            $path=$dir.'/'.$file;
            if($t-filemtime($path)>3600)
                @unlink($path);
        }
    }
    closedir($h);
}

class PDF extends FPDF
{
var $B;
var $I;
var $U;
var $HREF;

function PDF($orientation='P',$unit='mm',$format='A4',$_title,$_url, $_sitename, $_debug=false)
{
    CleanFiles('upload/PDF/');
    //Appel au constructeur parent
    $this->FPDF($orientation,$unit,$format);
    //Initialisation
    $this->B=0;
    $this->I=0;
    $this->U=0;
    $this->AliasNbPages();
    $this->articletitle=$_title;
    $this->articleurl=$_url;
    $this->sitename=$_sitename;
    $this->AddPage();
    $this->SetFontSize(10);
    $this->SetFont('helvetica');
}

function WriteHTML($html)
{
    //Parseur HTML
    		$str=array(
		'<br />' => '<br>',
		'<hr />' => '<hr>',
		'[r]' => '<red>',
		'[/r]' => '</red>',
		'[l]' => '<blue>',
		'[/l]' => '</blue>',
		'&#8220;' => '"',
		'&#8221;' => '"',
		'&#8222;' => '"',
		'&#8230;' => '...',
		'&#8217;' => '\'',
		'&gt;' => '>',
		'&lt;' => '<'
		);
		foreach ($str as $_from => $_to) $html = str_replace($_from,$_to,$html);
	$html=str_replace("\n",' ',$html);
    $a=preg_split('/<(.*)>/U',$html,-1,PREG_SPLIT_DELIM_CAPTURE);

    foreach($a as $i=>$e)
    {
        if($i%2==0)
        {
            //Texte
            if($this->HREF)
                $this->PutLink($this->HREF,$e);
            else
                $this->Write(5,$e);
        }
        else
        {
            //Balise
            if($e{0}=='/')
                $this->CloseTag(strtoupper(substr($e,1)));
            else
            {
                //Extraction des attributs
                $a2=explode(' ',$e);
                $tag=strtoupper(array_shift($a2));
                $attr=array();
                foreach($a2 as $v)
                    if(ereg('^([^=]*)=["\']?([^"\']*)["\']?$',$v,$a3))
                        $attr[strtoupper($a3[1])]=$a3[2];
                $this->OpenTag($tag,$attr);
            }
        }
    }

}

function OpenTag($tag,$attr)
{
    //Balise ouvrante
    switch($tag){
    	case 'B':
		case 'I':
		case 'U':
        	$this->SetStyle($tag,true);
        break;
        
   		case 'A':
        	$this->HREF=$attr['HREF'];
		break;
		
    	case 'BR':
        	$this->Ln(5);
        break;
        
		case 'IMG':
			if(isset($attr['SRC']) and (isset($attr['WIDTH']) or isset($attr['HEIGHT']))) {
				if(!isset($attr['WIDTH']))
					$attr['WIDTH'] = 0;
				if(!isset($attr['HEIGHT']))
					$attr['HEIGHT'] = 0;
				$this->Write(5,' ');
				$this->Image($attr['SRC'], $this->GetX(), $this->GetY(), px2mm($attr['WIDTH']), px2mm($attr['HEIGHT']));
				$this->Ln(px2mm($attr['HEIGHT']));
				$this->Write(5,'       ');
			}
			else
			{
               		    list($WIDTH, $HEIGHT) = @getimagesize($attr['SRC']);
               		    if(isset($WIDTH) && isset($HEIGHT) && $WIDTH != "" && $HEIGHT != "")
               		    {				               		    
               		        $this->Write(5,' ');
               		        $this->Image($attr['SRC'], $this->GetX(), $this->GetY(), px2mm($WIDTH), px2mm($HEIGHT));
               		        //$this->Ln(px2mm($attr['HEIGHT']));
               		        $this->Write(5,'       ');
               		    }
			}
   		break;
   		
   		case 'PAGEBREAK':
   		    $this->AddPage();
		break;

        case 'CODE':
            $this->Ln(2);
			$this->Line($this->GetX(),$this->GetY(),$this->GetX()+100,$this->GetY());
            $this->SetTextColor(0,0,255);
            $this->SetFont('times','',10);
		break;

	    case 'QUOTE':
            $this->Ln(2);
            $this->SetLeftMargin(20);
			$this->Line($this->GetX(),$this->GetY(),$this->GetX()+100,$this->GetY());
		break;
		
        case 'LI':
			$this->Ln(5);
			$this->SetTextColor(190,0,0);
			$this->Write(5,'        ');
		break;
		
		case 'FONT':
				if (isset($attr['COLOR']) and $attr['COLOR']!='') {
					$coul=hex2dec($attr['COLOR']);
					$this->SetTextColor($coul['R'],$coul['G'],$coul['B']);
					$this->issetcolor=true;
				}

				if (isset($attr['FACE']) and strtolower($attr['FACE'])=='arial' || strtolower($attr['FACE'])=='helvetica'|| strtolower($attr['FACE'])=='times'|| strtolower($attr['FACE'])=='courier'|| strtolower($attr['FACE'])=='symbol') {
					$this->SetFont(strtolower($attr['FACE']));
					$this->issetfont=true;
				}
				
				if (isset($attr['SIZE']) and $attr['SIZE']!='') {
                    $this->issetsize=true;
					switch($attr['SIZE']){
					    case '1':
					        $this->SetFontSize(8);
					    break;
						case '2':
						    $this->SetFontSize(10);
					    break;
					    case '3':
					        $this->SetFontSize(12);
					    break;
					    case '4':
					        $this->SetFontSize(14);
					    break;
					    case '5':
					        $this->SetFontSize(18);
					    break;
					    case '6':
					        $this->ln(2);
					        $this->SetFontSize(24);
					    break;
					    case '7':
					    $this->ln(4);
					        $this->SetFontSize(36);
					    break;}
				}
				break;
		}

}

function Footer()
	{
		//Go to 1.5 cm from bottom
		$this->SetY(-25);
		//Select Arial italic 8
		$this->SetFont('Helvetica','',8);
		//Print centered page number
		$this->Ln(7);
		$this->Line($this->GetX(),$this->GetY(),$this->GetX()+187,$this->GetY());
		$this->SetTextColor(0,0,0);
		$this->Cell(0,4,'Page '.$this->PageNo().'/{nb}',0,1,'C');
		$this->SetTextColor(0,0,180);
		$this->Cell(0,4,'html2pdf & FPDF class modified by Nuked-KlaN',0,1,'C','0','http://www.nuked-klan.org');
	}




	function Header()
	{
		$this->SetTextColor(0,0,255);
		$this->SetFont('Helvetica','',10);
		$this->Write(5,$this->sitename,$this->articleurl);
		$this->SetTextColor(0,0,0);
		$this->SetFont('Helvetica','',14);
		$this->Ln(10);
		$this->Cell(0,10,$this->articletitle,0,0,'C');
		$this->Ln(11);
		$this->Line($this->GetX(),$this->GetY(),$this->GetX()+187,$this->GetY());
	}

	
function CloseTag($tag)
{
    //Balise fermante
    if($tag=='B' or $tag=='I' or $tag=='U')
        $this->SetStyle($tag,false);
    if($tag=='A')
        $this->HREF='';

    if ($tag=='CODE'){
        $this->Ln(5);
		$this->Line($this->GetX(),$this->GetY(),$this->GetX()+100,$this->GetY());
		$this->SetTextColor(0,0,0);
		$this->SetFont('Helvetica','',10);
		$this->Ln(5);
	}
	if ($tag=='QUOTE'){
        $this->Ln(5);
		$this->Line($this->GetX(),$this->GetY(),$this->GetX()+100,$this->GetY());
		$this->Ln(5);
		$this->SetLeftMargin(10);
	}
	if ($tag=='LI'){
	    	$this->Ln(2);
			$this->SetTextColor(0,0,0);
	}
	if($tag=='FONT'){
			if ($this->issetcolor==true) {
				$this->SetTextColor(0,0,0);
			}
			if ($this->issetfont) {
				$this->SetFont('Times','',12);
				$this->issetfont=false;
			}
			if ($this->issetsize==true){
				$this->SetFontSize(10);
				$this->issetsize=false;
			}
		}

}


function SetStyle($tag,$enable)
{
    //Modifie le style et slectionne la police correspondante
    $this->$tag+=($enable ? 1 : -1);
    $style='';
    foreach(array('B','I','U') as $s)
        if($this->$s>0)
            $style.=$s;
    $this->SetFont('',$style);
}


function PutLink($URL,$txt)
{
    //Place un hyperlien
    $this->SetTextColor(0,0,255);
    $this->SetStyle('U',true);
    $this->Write(5,$txt,$URL);
    $this->SetStyle('U',false);
    $this->SetTextColor(0);
}
}

?>